<template lang="pug">
  .container
    h1.mt-5 Login
    div
      .form-signin
        .form-signin-social.h-100
          .wrap-social-login

            .wrap-button
              #google-signin-btn.mw-100.d-none
              button.btn.btn-primary.btn-google(
                type="button"
                @click="googleLogin"
                ) Sign in with Google
                img.social-image(src="../assets/images/logo/btn_google_light_normal_ios.svg")

      .d-flex.align-items-center
        .line
        p.m-0.px-5 or
        .line

      validation-observer(ref="validator")
        b-form(
          @reset='onReset'
          )
          validation-provider(name="Username" rules="required|email" v-slot="{ errors }")
            b-form-group#input-group-1(
              :class="{ 'has-error': errors[0] }"
              label='Email:'
              label-for='input-1'
              )
              b-form-input#input-1(
                v-model='form.email'
                type='email'
                required=''
                placeholder='Enter Username'
                )
              transition(name="fast-fade")
                .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

            validation-provider(name="Password" rules="required" v-slot="{ errors }")
              b-form-group#input-group-2(
                label='Password:'
                label-for='input-2'
                )
                b-form-input#input-2(
                  type="password"
                  v-model='form.password'
                  required=''
                  placeholder='Enter Password'
                  )
              transition(name="fast-fade")
                .text-danger.mt-1(v-if="errors[0]") {{ errors[0] }}

          b-button.mr-2(
            type='button'
            variant='primary'
            @click='onSubmit'
            ) Submit
          b-button(
            type='reset'
            variant='danger'
            ) Reset
</template>

<script>
// import _ from 'lodash'
import firebase from 'firebase/app'// Add the Firebase services that you want to use
import 'firebase/auth'
import 'firebase/firestore'

const firebaseConfig = {
  apiKey: 'AIzaSyA0L3LZo8Tuo8bP784u1uKjD_vtulND5F0',
  authDomain: 'vuejs-firebase-292ad.firebaseapp.com',
  databaseURL: 'https://vuejs-firebase-292ad.firebaseio.com',
  projectId: 'vuejs-firebase-292ad',
  storageBucket: 'vuejs-firebase-292ad.appspot.com',
  messagingSenderId: '107148710556',
  measurementId: 'G-XS973PG3ZJ'
}
firebase.initializeApp(firebaseConfig)

export default {
  name: 'Main',
  data () {
    return {
      form: {
        email: 'admin@admin.com',
        password: '123456'
      }
    }
  },
  methods: {
    async onSubmit (e) {
      const isFormValid = await this.$refs.validator.validate()
      if (!isFormValid) return
      firebase
        .auth()
        .signInWithEmailAndPassword(this.form.email, this.form.password)
        .then(
          user => {
            this.$router.replace('manage-user')
          },
          err => {
            alert(err.message)
          })
      e.preventDefault()
    },
    onReset (evt) {
      evt.preventDefault()
      // Reset our form values
      this.form = {
        username: '',
        password: ''
      }
    },

    googleLogin () {
      var provider = new firebase.auth.GoogleAuthProvider()
      firebase
        .auth()
        .signInWithPopup(provider)
        .then(
          user => {
            this.$router.replace('manage-user')
          },
          err => {
            alert(err.message)
          })
    }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>

.line {
  height: 1px;
  border-top: 1px solid #cccccc;
  width: 45%;
}

.has-error label {
  color: red;
}
</style>
